from random import random
from numpy import mean, zeros, dot, sqrt, pi
from scipy.special import gamma
import matplotlib.pyplot as plt

d_real = []
d_MC = []
ds = 25

for d in range(ds):
	n = 0
	N = 0
	for i in range(int(1e5)):
		r = zeros(d)
		for j in range(d):
			r[j] = random()
		if sqrt(dot(r, r)) <= 1:
			n += 1
		N += 1
	d_real.append(pi**(d/2) / gamma(1+d/2))
	d_MC.append(2**d * n / N)


def d_sphere(d):
	n = 0
	N = 0
	for i in range(int(1e7)):
		r = 0
		for j in range(d):
			r += random()**2
		if sqrt(r) <= 1:
			n += 1
		N += 1


plt.plot(range(ds), d_real, "o")
plt.plot(range(ds), d_MC, "o")
plt.show()

